__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain     PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ComboProc   PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EditProc    PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

include \masm32\macros\macros.asm

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400
WS_COMBO            equ     WS_VISIBLE+WS_CHILD+CBS_DROPDOWNLIST

.data
COMBOSTRUCT     STRUCT
cbi             COMBOBOXINFO        <>
lpDefComboProc  dd              ?
lpDefEditProc   dd              ?
COMBOSTRUCT     ENDS

hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>
UCSTR           ComboBoxClass,"COMBOBOX",0
hCombo          HWND            ?
cbi             COMBOBOXINFO    <>   
ComboStruct     COMBOSTRUCT     <>
rect            RECT            <>
TextBuffer      dw          256 dup(0)
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,0,addr ComboBoxClass,0,WS_COMBO,\
                        0,0,rect.right,100,hWnd,0,hInstance,0
            mov     hCombo,eax   
            mov     ComboStruct.cbi.cbSize,sizeof COMBOBOXINFO
            invoke  GetComboBoxInfo,hCombo,addr ComboStruct.cbi            
            invoke  SetWindowLong,hCombo,GWL_WNDPROC,addr ComboProc
            mov     ComboStruct.lpDefComboProc,eax
            invoke  SetWindowLong,ComboStruct.cbi.hwndItem,GWL_STYLE,WS_VISIBLE+WS_CHILD+ES_WANTRETURN+ES_AUTOHSCROLL
            invoke  SetWindowLong,ComboStruct.cbi.hwndItem,GWL_WNDPROC,addr EditProc
            mov     ComboStruct.lpDefEditProc,eax
            invoke  SendMessage,ComboStruct.cbi.hwndItem,EM_SETMARGINS,EC_LEFTMARGIN OR \
                    EC_RIGHTMARGIN,20002h
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_NOTIFY
        mov     edi,lParam
        .if     [edi.NMHDR].code==NM_DBLCLK
            invoke  Beep,400,20
            invoke  SetFocus,ComboStruct.cbi.hwndItem
        .endif            
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp            

ComboProc   PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_LBUTTONDOWN
        invoke  Beep,200,20
      ;  invoke  SetWindowPos,ComboStruct.cbi.hwndItem,HWND_TOP,0,0,0,0,SWP_SHOWWINDOW+SWP_NOMOVE
        invoke  SetFocus,ComboStruct.cbi.hwndItem
            
    .else        
        invoke  CallWindowProc,ComboStruct.lpDefComboProc,hWnd,uMsg,wParam,lParam
    .endif
    ret
    
ComboProc   endp

EditProc    PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_CHAR
        .if wParam==VK_RETURN
            invoke  SendMessage,ComboStruct.cbi.hwndItem,WM_GETTEXT,0,addr TextBuffer
            invoke  SendMessage,ComboStruct.cbi.hwndCombo,CB_ADDSTRING,0,addr TextBuffer
        .else
            xor     eax,eax
            mov     al,'a'
            invoke  CallWindowProc,ComboStruct.lpDefEditProc,hWnd,uMsg,eax,lParam
        .endif
    .elseif uMsg==WM_SETFOCUS
    .else                 
        invoke  CallWindowProc,ComboStruct.lpDefEditProc,hWnd,uMsg,wParam,lParam
    .endif
    ret
    
EditProc    endp
                                    
end     start